Options (Apache Tomcat 8.5.84 API Documentation)

Package org.apache.jasper

## Interface Options

- All Known Implementing Classes:
    `EmbeddedServletOptions`, `JspC`

      public interface Options

  A class to hold all init parameters specific to the JSP engine.
  Author:
    Anil K. Vijendran, Hans Bergsten, Pierre Delisle

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `genStringAsCharArray()` | Indicates whether text strings are to be generated as char arrays.
    `java.util.Map<java.lang.String,​TagLibraryInfo>` | `getCache()` | The web-application wide cache for the TagLibraryInfo tag library descriptors, used if `isCaching()` returns `true`.
    `int` | `getCheckInterval()` |
    `boolean` | `getClassDebugInfo()` |
    `java.lang.String` | `getClassPath()` |
    `java.lang.String` | `getCompiler()` | Compiler to use.
    `java.lang.String` | `getCompilerClassName()` |
    `java.lang.String` | `getCompilerSourceVM()` |
    `java.lang.String` | `getCompilerTargetVM()` |
    `boolean` | `getDevelopment()` | Main development flag, which enables detailed error reports with sources, as well automatic recompilation of JSPs and tag files.
    `boolean` | `getDisplaySourceFragment()` |
    `boolean` | `getErrorOnUseBeanInvalidClassAttribute()` | Returns true if Jasper issues a compilation error instead of a runtime Instantiation error if the class attribute specified in useBean action is invalid.
    `boolean` | `getFork()` | The boolean flag to tell Ant whether to fork JSP page compilations.
    `java.lang.String` | `getIeClassId()` | Gets the class-id value that is sent to Internet Explorer when using <jsp:plugin> tags.
    `java.lang.String` | `getJavaEncoding()` |
    `JspConfig` | `getJspConfig()` |
    `int` | `getJspIdleTimeout()` |
    `boolean` | `getKeepGenerated()` |
    `boolean` | `getMappedFile()` |
    `int` | `getMaxLoadedJsps()` | The maximum number of loaded jsps per web-application.
    `int` | `getModificationTestInterval()` |
    `boolean` | `getQuoteAttributeEL()` |
    `boolean` | `getRecompileOnFail()` |
    `java.io.File` | `getScratchDir()` |
    `boolean` | `getStrictQuoteEscaping()` |
    `TagPluginManager` | `getTagPluginManager()` |
    `TldCache` | `getTldCache()` | The cache that maps URIs, resource paths and parsed TLD files for the various tag libraries 'exposed' by the web application.
    `boolean` | `getTrimSpaces()` |
    `boolean` | `isCaching()` |
    `boolean` | `isPoolingEnabled()` |
    `boolean` | `isSmapDumped()` | This setting is ignored if suppressSmap() is `true`.
    `boolean` | `isSmapSuppressed()` |
    `boolean` | `isXpoweredBy()` |

- - ### Method Detail

    - #### getErrorOnUseBeanInvalidClassAttribute

          boolean getErrorOnUseBeanInvalidClassAttribute()

      Returns true if Jasper issues a compilation error instead of a runtime Instantiation error if the class attribute specified in useBean action is invalid.
      Returns:
        `true` to get an error

    - #### getKeepGenerated

          boolean getKeepGenerated()

      Returns:
        `true` to keep the generated source

    - #### isPoolingEnabled

          boolean isPoolingEnabled()

      Returns:
        `true` if tag handler pooling is enabled, `false` otherwise.

    - #### getMappedFile

          boolean getMappedFile()

      Returns:
        `true` if HTML mapped Servlets are supported.

    - #### getClassDebugInfo

          boolean getClassDebugInfo()

      Returns:
        `true` if debug information in included in compiled classes.

    - #### getCheckInterval

          int getCheckInterval()

      Returns:
        background compile thread check interval in seconds

    - #### getDevelopment

          boolean getDevelopment()

      Main development flag, which enables detailed error reports with sources, as well automatic recompilation of JSPs and tag files. This setting should usually be `false` when running in production.
      Returns:
        `true` if Jasper is in development mode

    - #### getDisplaySourceFragment

          boolean getDisplaySourceFragment()

      Returns:
        `true` to include a source fragment in exception messages.

    - #### isSmapSuppressed

          boolean isSmapSuppressed()

      Returns:
        `true` to suppress generation of SMAP info for JSR45 debugging.

    - #### isSmapDumped

          boolean isSmapDumped()

      This setting is ignored if suppressSmap() is `true`.
      Returns:
        `true` to write SMAP info for JSR45 debugging to a file.

    - #### getTrimSpaces

          boolean getTrimSpaces()

      Returns:
        `true` to remove template text that consists entirely of whitespace

    - #### getIeClassId

          java.lang.String getIeClassId()

      Gets the class-id value that is sent to Internet Explorer when using <jsp:plugin> tags.
      Returns:
        Class-id value

    - #### getScratchDir

          java.io.File getScratchDir()

      Returns:
        the work folder

    - #### getClassPath

          java.lang.String getClassPath()

      Returns:
        the classpath used to compile generated Servlets

    - #### getCompiler

          java.lang.String getCompiler()

      Compiler to use.

      If `null` (the default), the java compiler from Eclipse JDT project, bundled with Tomcat, will be used. Otherwise, the `javac` task from Apache Ant will be used to call an external java compiler and the value of this option will be passed to it. See Apache Ant documentation for the possible values.

      Returns:
        the compiler name

    - #### getCompilerTargetVM

          java.lang.String getCompilerTargetVM()

      Returns:
        the compiler target VM, e.g. 1.8.

    - #### getCompilerSourceVM

          java.lang.String getCompilerSourceVM()

      Returns:
        the compiler source VM, e.g. 1.8.

    - #### getCompilerClassName

          java.lang.String getCompilerClassName()

      Returns:
        Jasper Java compiler class to use.

    - #### getTldCache

          TldCache getTldCache()

      The cache that maps URIs, resource paths and parsed TLD files for the various tag libraries 'exposed' by the web application. A tag library is 'exposed' either explicitly in web.xml or implicitly via the uri tag in the TLD of a taglib deployed in a jar file (WEB-INF/lib).
      Returns:
        the instance of the TldLocationsCache for the web-application.

    - #### getJavaEncoding

          java.lang.String getJavaEncoding()

      Returns:
        Java platform encoding to generate the JSP page servlet.

    - #### getFork

          boolean getFork()

      The boolean flag to tell Ant whether to fork JSP page compilations.

      Is used only when Jasper uses an external java compiler (wrapped through a `javac` Apache Ant task).

      Returns:
        `true` to fork a process during compilation

    - #### getJspConfig

          JspConfig getJspConfig()

      Returns:
        JSP configuration information specified in web.xml.

    - #### isXpoweredBy

          boolean isXpoweredBy()

      Returns:
        `true` to generate a X-Powered-By response header.

    - #### getTagPluginManager

          TagPluginManager getTagPluginManager()

      Returns:
        a Tag Plugin Manager

    - #### genStringAsCharArray

          boolean genStringAsCharArray()

      Indicates whether text strings are to be generated as char arrays.
      Returns:
        `true` if text strings are to be generated as char arrays, `false` otherwise

    - #### getModificationTestInterval

          int getModificationTestInterval()

      Returns:
        modification test interval.

    - #### getRecompileOnFail

          boolean getRecompileOnFail()

      Returns:
        `true` if re-compile will occur on a failure.

    - #### isCaching

          boolean isCaching()

      Returns:
        `true` is caching is enabled (used for precompilation).

    - #### getCache

          java.util.Map<java.lang.String,​TagLibraryInfo> getCache()

      The web-application wide cache for the TagLibraryInfo tag library descriptors, used if `isCaching()` returns `true`.

      Using this cache avoids the cost of repeating the parsing of a tag library descriptor XML file (performed by TagLibraryInfoImpl.parseTLD).

      Returns:
        the Map(String uri, TagLibraryInfo tld) instance.

    - #### getMaxLoadedJsps

          int getMaxLoadedJsps()

      The maximum number of loaded jsps per web-application. If there are more jsps loaded, they will be unloaded. If unset or less than 0, no jsps are unloaded.
      Returns:
        The JSP count

    - #### getJspIdleTimeout

          int getJspIdleTimeout()

      Returns:
        the idle time in seconds after which a JSP is unloaded. If unset or less or equal than 0, no jsps are unloaded.

    - #### getStrictQuoteEscaping

          boolean getStrictQuoteEscaping()

      Returns:
        `true` if the quote escaping required by section JSP.1.6 of the JSP specification should be applied to scriplet expression.

    - #### getQuoteAttributeEL

          boolean getQuoteAttributeEL()

      Returns:
        `true` if EL expressions used within attributes should have the quoting rules in JSP.1.6 applied to the expression.